package br.usp.ime.evolvinggraph;

import static org.junit.Assert.assertEquals;

import java.util.List;

import org.junit.Test;

import br.usp.ime.algorithms.Algorithm;
import br.usp.ime.algorithms.ForemostAlgorithm;


public class ForemostAlgorithmTest {
	@Test
	public void testEGWithOneNodeShouldReturnEmptyJourney(){
		EvolvingGraph graph = new EvolvingGraph(1);
		Algorithm algorithm = new ForemostAlgorithm();
		List<Journey> emptyJourneys = algorithm.calculate(graph, graph.getNode(0));
		
		assertEquals(1, emptyJourneys.size());
		assertEquals(0, emptyJourneys.get(0).size);
	}
	
	@Test
	public void testInputTeste1(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste1.in");
		Algorithm algorithm = new ForemostAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey from0to0 = journeys.get(0);
		Journey from0to1 = journeys.get(1);
		
		assertEquals(0, from0to0.getArrivalDate());
		assertEquals(2, from0to1.getArrivalDate());
	}	
	@Test
	public void testInputTeste2(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste2.in");
		Algorithm algorithm = new ForemostAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		Journey journey = journeys.get(1);
		assertEquals(1, journey.getArrivalDate());
		journey = journeys.get(2);
		assertEquals(1, journey.getArrivalDate());
		journey = journeys.get(3);
		assertEquals(8, journey.getArrivalDate());
		journey = journeys.get(4);
		assertEquals(1, journey.getArrivalDate());
		journey = journeys.get(5);
		assertEquals(2, journey.getArrivalDate());
		journey = journeys.get(6);
		assertEquals(5, journey.getArrivalDate());
		journey = journeys.get(7);
		assertEquals(4, journey.getArrivalDate());
		journey = journeys.get(8);
		assertEquals(4, journey.getArrivalDate());
		journey = journeys.get(9);
		assertEquals(5, journey.getArrivalDate());
		journey = journeys.get(10);
		assertEquals(7, journey.getArrivalDate());
		journey = journeys.get(11);
		assertEquals(5, journey.getArrivalDate());
	}	
	@Test
	public void testInputTeste3(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste3.in");
		Algorithm algorithm = new ForemostAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		Journey journey = journeys.get(1);
		assertEquals(1, journey.getArrivalDate());
		journey = journeys.get(2);
		assertEquals(1, journey.getArrivalDate());
		journey = journeys.get(3);
		assertEquals(1, journey.getArrivalDate());
		journey = journeys.get(4);
		assertEquals(1, journey.getArrivalDate());
	}
	@Test
	public void testInputTeste4(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste4.in");
		Algorithm algorithm = new ForemostAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		Journey journey = journeys.get(1);
		assertEquals(3, journey.getArrivalDate());
		journey = journeys.get(2);
		assertEquals(2, journey.getArrivalDate());
		journey = journeys.get(3);
		assertEquals(4, journey.getArrivalDate());
		journey = journeys.get(4);
		assertEquals(4, journey.getArrivalDate());
		journey = journeys.get(5);
		assertEquals(5, journey.getArrivalDate());
		journey = journeys.get(6);
		assertEquals(10, journey.getArrivalDate());
		journey = journeys.get(7);
		assertEquals(7, journey.getArrivalDate());
	}
	@Test
	public void testInputFromONE3(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraphFromONE("input/testeONE3.in", 126, 5000);
		Algorithm algorithm = new ForemostAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		System.out.println(journeys);
	}
}
