#!/usr/bin/perl -w

package Toolkit;
use strict;
use warnings;
use Getopt::Long;
use FileHandle;

my @algoritmos = ("Foremost", "Shortest", "Fastest");#, "Epidemic", "MaxProp", "Prophet");
#my @algoritmos = ("MaxProp", "Prophet", "Shortest");
my %labelX = (
	"raio" => "Raio de Transmissao",
	#"buffer" => "Buffer Size",
	"nos" => "Numero de Nos",
	#"mensagens" => "Message Size"
);
my %labelY = (
#	"Delivered" => "Delivery Probability",
#	"Hopcount" => "Average Hopcount",
#	"Latency" => "Latency",
#	"Relayed" => "Relayed Messages",
#	"TransitTime" => "Transit Time",
	"Time" => "Tempo de execucao"
);

foreach my $x (keys %labelX){
	foreach my $y (keys %labelY){
		my $naoEhPrimeiro;
		open (TEMP, ">temp_gnuplot.txt") or die "Couldn't open the gnuplot file";
		print TEMP "set terminal png\n";
		print TEMP "set output '..\/results\/graphics\/$x"."$y.png'\n";
		print TEMP "set title '$labelX{$x} x $labelY{$y}'\n";
		print TEMP "set ylabel '$labelY{$y}'\n";
		print TEMP "set xlabel '$labelX{$x}'\n";
		print TEMP "plot ";
		foreach my $Alg (@algoritmos){
			my $alg = lc($Alg);
			if (-e "../results/$alg"."_$x"."_$y") {
				if ($naoEhPrimeiro){
					print TEMP ",";
				}
				print TEMP " '../results/$alg"."_$x"."_$y' title '$Alg' with yerrorlines lw 2";
				$naoEhPrimeiro = "true";
			}
		}
		print TEMP "\n";
		close (TEMP);
		system("gnuplot temp_gnuplot.txt");	
	}
}
system("rm -f ../temp_gnuplot.txt");	
